Spring Data JDBC Changelog
=========================

Changes in version 2.3.0-M1 (2021-07-16)
----------------------------------------
* #1000 - No connections in poll available when performing multiple queries in parallel.
* #992 - Convert AggregateReference using Converters instead of custom code paths.
* #987 - Support `AggregateReference` in derived query methods.
* #980 - Add support for repository query method projections.
* #979 - Fix Readme section about creating issues.
* #978 - Handle ConstantCondition in ConditionVisitor.
* #975 - Fixes build failures with JDK16.
* #974 - After Upgrading spring-data-jdbbc from 1.1.12.RELEASE to 2.0.6.RELEASE LocalDateTime parameters in Repository methods fail.
* #972 - Fix split-package between `spring.data.jdbc` and `spring.data.relational`.
* #971 - Add support for projections using repository query methods.
* #946 - Update CI to Java 16.
* #935 - spring-data-jdbc and postgres: Trailing junk on timestamp.
* #934 - Properly document AggregateReference.
* #908 - MSSQL bit wrongly mapped to boolean value TRUE.
* #907 - org.springframework.data.relational.core.sql.render.ConditionVisitor does not handle ConstantConditions.
* #578 - Support for reading large resultsets [DATAJDBC-356].


Changes in version 2.1.11 (2021-07-16)
--------------------------------------


Changes in version 2.2.2 (2021-06-22)
-------------------------------------
* #979 - Fix Readme section about creating issues.
* #975 - Fixes build failures with JDK16.
* #972 - Fix split-package between `spring.data.jdbc` and `spring.data.relational`.


Changes in version 2.1.10 (2021-06-22)
--------------------------------------
* #979 - Fix Readme section about creating issues.
* #975 - Fixes build failures with JDK16.
* #972 - Fix split-package between `spring.data.jdbc` and `spring.data.relational`.


Changes in version 2.2.1 (2021-05-14)
-------------------------------------


Changes in version 2.1.9 (2021-05-14)
-------------------------------------


Changes in version 2.2.0 (2021-04-14)
-------------------------------------
* #961 - Upgrade dependencies.
* #952 - Add support for `Slice` and `Page` queries using query derivation.
* #951 - Improve documentation of entity state detection.
* #774 - Add support for queries returning Page and Slice.


Changes in version 2.1.8 (2021-04-14)
-------------------------------------
* #961 - Upgrade dependencies.
* #951 - Improve documentation of entity state detection.


Changes in version 2.0.9.RELEASE (2021-04-14)
---------------------------------------------
* #953 - Fix small typo in dialect section.
* #947 - Docs on "query derivation" contradicts.
* #945 - ClassCastException on primitive arrays parameters in spring-data-jdbc 2.x.x.


Changes in version 2.1.7 (2021-03-31)
-------------------------------------
* #953 - Fix small typo in dialect section.
* #947 - Docs on "query derivation" contradicts.
* #945 - ClassCastException on primitive arrays parameters in spring-data-jdbc 2.x.x.


Changes in version 2.2.0-RC1 (2021-03-31)
-----------------------------------------
* #953 - Fix small typo in dialect section.
* #947 - Docs on "query derivation" contradicts.
* #945 - ClassCastException on primitive arrays parameters in spring-data-jdbc 2.x.x.


Changes in version 2.2.0-M5 (2021-03-17)
----------------------------------------
* #939 - Don't retrieve generated keys on INSERT if primary key is defined.
* #938 - Move to Spring Data Commons' association abstraction.
* #937 - JdbcCustomConversion does not reject non-Date related default converters anymore.
* #933 - Generated keys are retrieved even if the primary key value is defined.
* #929 - Add Query by Example support.


Changes in version 2.1.6 (2021-03-17)
-------------------------------------


Changes in version 2.0.8.RELEASE (2021-03-17)
---------------------------------------------


Changes in version 2.2.0-M4 (2021-02-18)
----------------------------------------


Changes in version 2.1.5 (2021-02-18)
-------------------------------------


Changes in version 2.2.0-M3 (2021-02-17)
----------------------------------------
* DATAJDBC-620 - ResultSetExtractor can not use default row mapper.
* #916 - Fixes Conditions.notIn() by using 'In.createNotIn()'.
* #914 - SqlServerDialect should be case sensitive.
* #911 - Fix documentation of callbacks.
* #910 - Trigger BeforeConvertEvent when saving an entity.
* #257 - Update repository after GitHub issues migration.


Changes in version 2.1.4 (2021-02-17)
-------------------------------------
* DATAJDBC-620 - ResultSetExtractor can not use default row mapper.
* #916 - Fixes Conditions.notIn() by using 'In.createNotIn()'.
* #911 - Fix documentation of callbacks.
* #910 - Trigger BeforeConvertEvent when saving an entity.


Changes in version 2.0.7.RELEASE (2021-02-17)
---------------------------------------------
* DATAJDBC-642 - Update CI jobs with Docker Login.
* DATAJDBC-637 - Support nanosecond precision by converting to Timestamp instead of Date.
* #916 - Fixes Conditions.notIn() by using 'In.createNotIn()'.
* #911 - Fix documentation of callbacks.
* #904 - Update copyright year to 2021.
* #257 - Update repository after GitHub issues migration.


Changes in version 1.1.13.RELEASE (2021-02-17)
----------------------------------------------
* #921 - The 1.1.x build is broken.
* #916 - Fixes Conditions.notIn() by using 'In.createNotIn()'.
* #904 - Update copyright year to 2021.


Changes in version 2.2.0-M2 (2021-01-13)
----------------------------------------
* DATAJDBC-642 - Update CI jobs with Docker Login.
* DATAJDBC-637 - Support nanosecond precision by converting to Timestamp instead of Date.
* #904 - Update copyright year to 2021.
* #257 - Update repository after GitHub issues migration.


Changes in version 2.1.3 (2021-01-13)
-------------------------------------
* DATAJDBC-642 - Update CI jobs with Docker Login.
* DATAJDBC-637 - Support nanosecond precision by converting to Timestamp instead of Date.
* #904 - Update copyright year to 2021.
* #257 - Update repository after GitHub issues migration.


Changes in version 2.1.2 (2020-12-09)
-------------------------------------
* DATAJDBC-633 - Release 2.1.2 (2020.0.2).


Changes in version 2.2.0-M1 (2020-12-09)
----------------------------------------
* DATAJDBC-629 - Implement CrudRepository.delete(Iterable<ID> ids).
* DATAJDBC-628 - Enable Maven caching for Jenkins jobs.
* DATAJDBC-627 - Release 2.2 M1 (2021.0.0).
* DATAJDBC-531 - Skip count query if Page Query result page size is 1.


Changes in version 2.0.6.RELEASE (2020-12-09)
---------------------------------------------
* DATAJDBC-628 - Enable Maven caching for Jenkins jobs.
* DATAJDBC-625 - Release 2.0.6 (Neumann SR6).


Changes in version 1.1.12.RELEASE (2020-12-09)
----------------------------------------------
* DATAJDBC-628 - Enable Maven caching for Jenkins jobs.
* DATAJDBC-624 - Release 1.1.12 (Moore SR12).


Changes in version 2.1.1 (2020-11-11)
-------------------------------------
* DATAJDBC-628 - Enable Maven caching for Jenkins jobs.
* DATAJDBC-626 - Release 2.1.1 (2020.0.1).


Changes in version 2.1.0 (2020-10-28)
-------------------------------------
* DATAJDBC-622 - Add support for transactionManagerRef in EnableJdbcRepository.
* DATAJDBC-616 - Migrate to JUnit 5.
* DATAJDBC-615 - Release 2.1 GA (2020.0.0).
* DATAJDBC-522 - Add Kotlin extensions for Criteria.


Changes in version 2.0.5.RELEASE (2020-10-28)
---------------------------------------------
* DATAJDBC-614 - Query.with(Pageable) does not properly combine sorts.
* DATAJDBC-610 - Small documentation fix.
* DATAJDBC-601 - Release 2.0.5 (Neumann SR5).
* DATAJDBC-596 - LessThanEqual renders ligature instead of operator in reference documentation.


Changes in version 1.1.11.RELEASE (2020-10-28)
----------------------------------------------
* DATAJDBC-600 - Release 1.1.11 (Moore SR11).


Changes in version 1.0.21.RELEASE (2020-10-28)
----------------------------------------------
* DATAJDBC-621 - Release 1.0.21 (Lovelace SR21).


Changes in version 2.1.0-RC2 (2020-10-14)
-----------------------------------------
* DATAJDBC-614 - Query.with(Pageable) does not properly combine sorts.
* DATAJDBC-610 - Small documentation fix.
* DATAJDBC-606 - Adopt to changes in Spring Data Commons.
* DATAJDBC-604 - Usage of In operator with emptyList.
* DATAJDBC-602 - Release 2.1 RC2 (2020.0.0).
* DATAJDBC-596 - LessThanEqual renders ligature instead of operator in reference documentation.
* DATAJDBC-508 - Add support for @Value.
* DATAJDBC-430 - Make row mappers to be a spring bean.
* DATAJDBC-349 - JdbcCustomConversions not applied to primary key on lookup.


Changes in version 2.1.0-RC1 (2020-09-16)
-----------------------------------------
* DATAJDBC-598 - Adapt to changed Spring Framework CollectionUtils.
* DATAJDBC-590 - Release 2.1 RC1 (2020.0.0).


Changes in version 2.0.4.RELEASE (2020-09-16)
---------------------------------------------
* DATAJDBC-591 - Release 2.0.4 (Neumann SR4).


Changes in version 1.1.10.RELEASE (2020-09-16)
----------------------------------------------
* DATAJDBC-583 - Wording changes.
* DATAJDBC-581 - Release 1.1.10 (Moore SR10).


Changes in version 1.0.20.RELEASE (2020-09-16)
----------------------------------------------
* DATAJDBC-583 - Wording changes.
* DATAJDBC-580 - Release 1.0.20 (Lovelace SR20).


Changes in version 2.0.3.RELEASE (2020-08-12)
---------------------------------------------
* DATAJDBC-586 - Guard JdbcRepositoryFactoryBean against setting null values for properties.
* DATAJDBC-583 - Wording changes.
* DATAJDBC-582 - Release 2.0.3 (Neumann SR3).


Changes in version 2.1.0-M2 (2020-08-12)
----------------------------------------
* DATAJDBC-586 - Guard JdbcRepositoryFactoryBean against setting null values for properties.
* DATAJDBC-583 - Wording changes.
* DATAJDBC-576 - Control test execution with missing licence via profile.
* DATAJDBC-574 - Add MS SqlServer Integration tests to the CI pipeline.
* DATAJDBC-573 - Fix failing Oracle integration test due to the database not being ready.
* DATAJDBC-572 - Enable specification of a repository base class in @EnableJdbcRepositories.
* DATAJDBC-571 - Release 2.1 M2 (2020.0.0).
* DATAJDBC-570 - Remove AS from join alias.
* DATAJDBC-569 - Support temporal properties with Oracle.
* DATAJDBC-559 - DialectResolver does not resolve MySqlDialect for MariaDB.
* DATAJDBC-256 - Run integration tests with Oracle.


Changes in version 2.0.2.RELEASE (2020-07-22)
---------------------------------------------
* DATAJDBC-569 - Support temporal properties with Oracle.
* DATAJDBC-564 - Release 2.0.2 (Neumann SR2).
* DATAJDBC-559 - DialectResolver does not resolve MySqlDialect for MariaDB.


Changes in version 1.1.9.RELEASE (2020-07-22)
---------------------------------------------
* DATAJDBC-563 - Release 1.1.9 (Moore SR9).


Changes in version 1.0.19.RELEASE (2020-07-22)
----------------------------------------------
* DATAJDBC-562 - Release 1.0.19 (Lovelace SR19).


Changes in version 2.1.0-M1 (2020-06-25)
----------------------------------------
* DATAJDBC-561 - Use standard Spring code of conduct.
* DATAJDBC-560 - QueryMapper fails when using Criteria.from(…) with two or more criteria.
* DATAJDBC-555 - Document supported databases.
* DATAJDBC-547 - "PSQLException: ERROR: FOR UPDATE must specify unqualified relation names" when calling deleteById for an aggregate with references to other tables.
* DATAJDBC-546 - Skip property population if entity can be constructed entirely using a full constructor.
* DATAJDBC-545 - withId seems to be mandatory even the documentation states it should be optional.
* DATAJDBC-544 - Delombok source files.
* DATAJDBC-542 - Version 2.0 broke MyBatis support.
* DATAJDBC-541 - Release 2.1 M1 (2020.0.0).
* DATAJDBC-539 - CriteriaFactory double-wraps collection values for IN queries.


Changes in version 2.0.1.RELEASE (2020-06-10)
---------------------------------------------
* DATAJDBC-560 - QueryMapper fails when using Criteria.from(…) with two or more criteria.
* DATAJDBC-555 - Document supported databases.
* DATAJDBC-547 - "PSQLException: ERROR: FOR UPDATE must specify unqualified relation names" when calling deleteById for an aggregate with references to other tables.
* DATAJDBC-546 - Skip property population if entity can be constructed entirely using a full constructor.
* DATAJDBC-545 - withId seems to be mandatory even the documentation states it should be optional.
* DATAJDBC-542 - Version 2.0 broke MyBatis support.
* DATAJDBC-540 - Release 2.0.1 (Neumann SR1).
* DATAJDBC-539 - CriteriaFactory double-wraps collection values for IN queries.
* DATAJDBC-412 - Custom value type can't be used as Id.


Changes in version 1.1.8.RELEASE (2020-06-10)
---------------------------------------------
* DATAJDBC-546 - Skip property population if entity can be constructed entirely using a full constructor.
* DATAJDBC-545 - withId seems to be mandatory even the documentation states it should be optional.
* DATAJDBC-532 - Remove Travis CI.
* DATAJDBC-527 - Release 1.1.8 (Moore SR8).


Changes in version 1.0.18.RELEASE (2020-06-10)
----------------------------------------------
* DATAJDBC-545 - withId seems to be mandatory even the documentation states it should be optional.
* DATAJDBC-532 - Remove Travis CI.
* DATAJDBC-525 - Release 1.0.18 (Lovelace SR18).


Changes in version 2.0.0.RELEASE (2020-05-12)
---------------------------------------------
* DATAJDBC-538 - Locks do not work for DB2.
* DATAJDBC-534 - Derived Query support count projection.
* DATAJDBC-532 - Remove Travis CI.
* DATAJDBC-530 - The sorting property might be set as the property name.
* DATAJDBC-529 - Derived query existsByToken throws exception when entity doesn't exists.
* DATAJDBC-528 - Release 2.0 GA (Neumann).
* DATAJDBC-493 - Deadlock occurs when competing with Jdbc Repository Update and Delete.
* DATAJDBC-257 - Run integration tests with IBM DB2.


Changes in version 2.0.0.RC2 (2020-04-28)
-----------------------------------------
* DATAJDBC-520 - Improve documentation for MappedCollection.
* DATAJDBC-518 - Allow combination of CriteriaDefinition instances.
* DATAJDBC-517 - Release 2.0 RC2 (Neumann).
* DATAJDBC-507 - Change starting versions for optimistic locking to the schema used in the rest of Spring Data.
* DATAJDBC-480 - Move off deprecated EntityInstantiators.
* DATAJDBC-318 - Derived Queries.


Changes in version 1.1.7.RELEASE (2020-04-28)
---------------------------------------------
* DATAJDBC-520 - Improve documentation for MappedCollection.
* DATAJDBC-511 - Release 1.1.7 (Moore SR7).


Changes in version 1.0.17.RELEASE (2020-04-28)
----------------------------------------------
* DATAJDBC-509 - Fix findByFirstnameLike @Query example in README.
* DATAJDBC-506 - Fix some typos in code and documentation.
* DATAJDBC-495 - Release 1.0.17 (Lovelace SR17).


Changes in version 2.0.0.RC1 (2020-03-31)
-----------------------------------------
* DATAJDBC-516 - BasicRelationalConverter too aggressively trying to convert entities.
* DATAJDBC-514 - Add infrastructure for query derivation in Spring Data Relational.
* DATAJDBC-513 - Introduce Query, Criteria and Update Objects for Spring Data Relational.
* DATAJDBC-512 - Add default dialect for H2 Database.
* DATAJDBC-510 - Add BasicJdbcConverter constructor with IdentifierProcessing.
* DATAJDBC-509 - Fix findByFirstnameLike @Query example in README.
* DATAJDBC-506 - Fix some typos in code and documentation.
* DATAJDBC-504 - Release 2.0 RC1 (Neumann).
* DATAJDBC-487 - Default IdentifierProcessing should respect JDBC driver's setting.
* DATAJDBC-455 - Database Dialect discovery.
* DATAJDBC-454 - Remove ids from events where full entities are present.
* DATAJDBC-453 - Bring DbAction and AggregateChange into a form that is somewhat future proof.
* DATAJDBC-341 - Map NULL values in EntityRowMapper for columns not being fetched in the query.


Changes in version 1.1.6.RELEASE (2020-03-25)
---------------------------------------------
* DATAJDBC-509 - Fix findByFirstnameLike @Query example in README.
* DATAJDBC-506 - Fix some typos in code and documentation.
* DATAJDBC-496 - Release 1.1.6 (Moore SR6).


Changes in version 2.0.0.M4 (2020-03-11)
----------------------------------------
* DATAJDBC-503 - Adapt to Mockito 3.3 changes.
* DATAJDBC-492 - AbstractJdbcConfiguration should use JdbcMappingContext instead of RelationalMappingContext.
* DATAJDBC-491 - Quoting all database identifiers breaks queries to tables in custom schema.
* DATAJDBC-490 - Support condition nesting.
* DATAJDBC-488 - Deadlock occurs when competing with Jdbc Repository Update.
* DATAJDBC-486 - Release 2.0 M4 (Neumann).
* DATAJDBC-381 - Using backticks in column names leads to failure during INSERT with MySQL.


Changes in version 1.1.5.RELEASE (2020-02-26)
---------------------------------------------
* DATAJDBC-488 - Deadlock occurs when competing with Jdbc Repository Update.
* DATAJDBC-483 - Correct reference docs.
* DATAJDBC-472 - Release 1.1.5 (Moore SR5).


Changes in version 1.0.16.RELEASE (2020-02-26)
----------------------------------------------
* DATAJDBC-485 - Travis Build is broken for branch 1.0.x.
* DATAJDBC-483 - Correct reference docs.
* DATAJDBC-471 - Release 1.0.16 (Lovelace SR16).


Changes in version 2.0.0.M3 (2020-02-12)
----------------------------------------
* DATAJDBC-484 - Date related tests in JdbcRepositoryIntegrationTests fail with Java 11.
* DATAJDBC-483 - Correct reference docs.
* DATAJDBC-481 - Immutable entity class vs optimistic locking: version-field not incremented by save().
* DATAJDBC-479 - Use SqlIdentifier in Table and Column name.
* DATAJDBC-478 - Expose arguments of o.s.d.r.c.sql.SimpleFunction.
* DATAJDBC-474 - Release 2.0 M3 (Neumann).
* DATAJDBC-464 - Apply conversions to parameters of methods.
* DATAJDBC-386 - Always quote identifiers.
* DATAJDBC-101 - Support for PagingRepositories.


Changes in version 2.0.0.M2 (2020-01-17)
----------------------------------------
* DATAJDBC-473 - Release 2.0 M2 (Neumann).


Changes in version 2.0.0.M1 (2020-01-16)
----------------------------------------
* DATAJDBC-469 - Bump version to 2.0.0.
* DATAJDBC-466 - Update copyright years to 2020.
* DATAJDBC-462 - MySql doesn't return rows matched by update but rows actually changed by update.
* DATAJDBC-461 - Make Integration tests react to environment variables and system properties.
* DATAJDBC-451 - The documentation is missing the what's new section for Moor.
* DATAJDBC-448 - NamingStrategy: Documentation referencing wrong ReverseColumnName method.
* DATAJDBC-447 - Fix JDK 8 Travis build.
* DATAJDBC-442 - Enable Java 11+ builds.
* DATAJDBC-441 - Indent MyBatis integration sections in the documentation.
* DATAJDBC-438 - Saving a record with an id that doesn't exist should return an error/warning to caller.
* DATAJDBC-437 - Spring Data JDBC does not consider properly strict configuration mode.
* DATAJDBC-436 - Replaces the deprecated @Wither with the new @With.
* DATAJDBC-434 - CONTRIBUTING.adoc is missing.
* DATAJDBC-432 - Separation of AggregateChange and MappingContext.
* DATAJDBC-431 - @ReadOnlyProperty is not honoured by Spring Data JDBC.
* DATAJDBC-428 - EntityRowMapper can not extract AggregateReference field for immutable entity.
* DATAJDBC-427 - Implements equalsAndHashCode for AggregateReference.
* DATAJDBC-424 - Release 2.0 M1 (Neumann).
* DATAJDBC-417 - Saving an aggregate with null embeddable referencing an entity fails.
* DATAJDBC-291 - Nested data structure with Spring Data JDBC.
* DATAJDBC-234 - Support properties file based query declaration mechanism.
* DATAJDBC-219 - Support for optimistic locking.


Changes in version 1.1.4.RELEASE (2020-01-15)
---------------------------------------------
* DATAJDBC-466 - Update copyright years to 2020.
* DATAJDBC-458 - Release 1.1.4 (Moore SR4).
* DATAJDBC-291 - Nested data structure with Spring Data JDBC.


Changes in version 1.0.15.RELEASE (2020-01-15)
----------------------------------------------
* DATAJDBC-466 - Update copyright years to 2020.
* DATAJDBC-457 - Release 1.0.15 (Lovelace SR15).


Changes in version 1.1.3.RELEASE (2019-12-04)
---------------------------------------------
* DATAJDBC-451 - The documentation is missing the what's new section for Moor.
* DATAJDBC-447 - Fix JDK 8 Travis build.
* DATAJDBC-446 - Release 1.1.3 (Moore SR3).


Changes in version 1.0.14.RELEASE (2019-12-04)
----------------------------------------------
* DATAJDBC-448 - NamingStrategy: Documentation referencing wrong ReverseColumnName method.
* DATAJDBC-445 - Release 1.0.14 (Lovelace SR14).


Changes in version 1.1.2.RELEASE (2019-11-18)
---------------------------------------------
* DATAJDBC-441 - Indent MyBatis integration sections in the documentation.
* DATAJDBC-440 - Release 1.1.2 (Moore SR2).
* DATAJDBC-417 - Saving an aggregate with null embeddable referencing an entity fails.


Changes in version 1.0.13.RELEASE (2019-11-18)
----------------------------------------------
* DATAJDBC-439 - Release 1.0.13 (Lovelace SR13).


Changes in version 1.1.1.RELEASE (2019-11-04)
---------------------------------------------
* DATAJDBC-437 - Spring Data JDBC does not consider properly strict configuration mode.
* DATAJDBC-434 - CONTRIBUTING.adoc is missing.
* DATAJDBC-431 - @ReadOnlyProperty is not honoured by Spring Data JDBC.
* DATAJDBC-428 - EntityRowMapper can not extract AggregateReference field for immutable entity.
* DATAJDBC-427 - Implements equalsAndHashCode for AggregateReference.
* DATAJDBC-423 - Release 1.1.1 (Moore SR1).


Changes in version 1.0.12.RELEASE (2019-11-04)
----------------------------------------------
* DATAJDBC-437 - Spring Data JDBC does not consider properly strict configuration mode.
* DATAJDBC-434 - CONTRIBUTING.adoc is missing.
* DATAJDBC-422 - Release 1.0.12 (Lovelace SR12).


Changes in version 1.1.0.RELEASE (2019-09-30)
---------------------------------------------
* DATAJDBC-419 - Inherit Jacoco configuration from parent pom.
* DATAJDBC-413 - Use proper https links for mybatis DTDs.
* DATAJDBC-411 - Beginning with the RC for Moore Javadoc doesn't get published anymore.
* DATAJDBC-410 - NOT IN doesn't get redered correctly.
* DATAJDBC-403 - Release 1.1 GA (Moore).


Changes in version 1.0.11.RELEASE (2019-09-30)
----------------------------------------------
* DATAJDBC-413 - Use proper https links for mybatis DTDs.
* DATAJDBC-402 - Release 1.0.11 (Lovelace SR11).


Changes in version 1.1.0.RC3 (2019-09-06)
-----------------------------------------
* DATAJDBC-405 - Unresolved directives in Docs.
* DATAJDBC-404 - Release 1.1 RC3 (Moore).


Changes in version 1.1.0.RC2 (2019-08-05)
-----------------------------------------
* DATAJDBC-400 - Remove Identifier from EntityCallback notification.
* DATAJDBC-398 - Make SimpleJdbcRepository transactional.
* DATAJDBC-395 - General overhaul of (Abstract)JdbcConfiguration and MyBatis integration.
* DATAJDBC-394 - the genereated AS in table alias not supported  in Oracle.
* DATAJDBC-393 - Use the new EntityCallback infrastructure.
* DATAJDBC-391 - Revise readme for a consistent structure.
* DATAJDBC-390 - Auditing never considers an instance as new if the id is set in a listener.
* DATAJDBC-388 - Release 1.1 RC2 (Moore).
* DATAJDBC-383 - Remove http reference to mybatis dtd.
* DATAJDBC-376 - Introduce Jenkins CI.


Changes in version 1.0.10.RELEASE (2019-08-05)
----------------------------------------------
* DATAJDBC-390 - Auditing never considers an instance as new if the id is set in a listener.
* DATAJDBC-387 - Release 1.0.10 (Lovelace SR10).
* DATAJDBC-383 - Remove http reference to mybatis dtd.
* DATAJDBC-376 - Introduce Jenkins CI.


Changes in version 1.1.0.RC1 (2019-06-14)
-----------------------------------------
* DATAJDBC-384 - Improve backward compatibility for MybatisDataAccessStrategy.
* DATAJDBC-382 - Create security policy readme.
* DATAJDBC-378 - IllegalArgumentException: JdbcValue must be not null at this point.
* DATAJDBC-377 - Use testcontainers version property.
* DATAJDBC-374 - Make behavior for empty embeddables configurable.
* DATAJDBC-360 - Release 1.1 RC1 (Moore).
* DATAJDBC-223 - Collection like properties of entities without id property need special handling.


Changes in version 1.0.9.RELEASE (2019-06-14)
---------------------------------------------
* DATAJDBC-378 - IllegalArgumentException: JdbcValue must be not null at this point.
* DATAJDBC-372 - Release 1.0.9 (Lovelace SR9).


Changes in version 1.0.8.RELEASE (2019-05-13)
---------------------------------------------
* DATAJDBC-371 - Release 1.0.8 (Lovelace SR8).


Changes in version 1.1.0.M4 (2019-05-13)
----------------------------------------
* DATAJDBC-370 - Can't set attribute of embeddable with only a constructor for arguments.
* DATAJDBC-365 - Fix typos in readme.
* DATAJDBC-363 - Release 1.1 M4 (Moore).
* DATAJDBC-361 - Fix minor typos in SqlGenerator.
* DATAJDBC-359 - Chains of entities without id should work and reference the topmost entity.


Changes in version 1.0.7.RELEASE (2019-05-10)
---------------------------------------------
* DATAJDBC-365 - Fix typos in readme.
* DATAJDBC-351 - Release 1.0.7 (Lovelace SR7).


Changes in version 1.1.0.M3 (2019-04-11)
----------------------------------------
* DATAJDBC-357 - Introduce dialect support to render paginated queries.
* DATAJDBC-355 - Remove unnecessary null check in converters.
* DATAJDBC-354 - Fix test fixture after Mockito upgrade.
* DATAJDBC-347 - SelectBuilder (SelectAndFrom) does not override from(String).
* DATAJDBC-346 - HSQLDB integration tests fail when the MSSQL database is used.
* DATAJDBC-343 - INSERT and UPDATE statement assignments contain table prefix.
* DATAJDBC-340 - Use infrastructure for semantic SQL generation in Spring Data JDBC.
* DATAJDBC-337 - Release 1.1 M3 (Moore).
* DATAJDBC-327 - Add support for conversion to JdbcValue and store byte[] as binary.


Changes in version 1.0.6.RELEASE (2019-04-01)
---------------------------------------------
* DATAJDBC-334 - How to escape case sensitive identifiers?.
* DATAJDBC-333 - Release 1.0.6 (Lovelace SR6).


Changes in version 1.1.0.M2 (2019-03-07)
----------------------------------------
* DATAJDBC-335 - Add StatementBuilder's for INSERT, UPDATE, and DELETE.
* DATAJDBC-334 - How to escape case sensitive identifiers?.
* DATAJDBC-331 - Introduce @MappedCollection annotation replacing @Column(keyColumn).
* DATAJDBC-330 - JdbcRepositoryConfigExtension looks up beans before they get registered.
* DATAJDBC-329 - Fix accidentially broken API.
* DATAJDBC-326 - ID of one-to-many relationship not properly converted.
* DATAJDBC-325 - SqlGeneratorSource needs thread safety.
* DATAJDBC-324 - Implement support of ReadOnlyProperty annotation.
* DATAJDBC-322 - Update Mybatis dependencies.
* DATAJDBC-316 - Introduce Concourse CI.
* DATAJDBC-313 - Update copyright years to 2019.
* DATAJDBC-309 - Add infrastructure for semantic SQL generation.
* DATAJDBC-308 - Release 1.1 M2 (Moore).
* DATAJDBC-307 - Add distribution module for Spring Data JDBC.
* DATAJDBC-303 - Fix flaky test.
* DATAJDBC-296 - Allow plain @Table use without providing a table name.
* DATAJDBC-293 - @EnableJdbcRepositories support multi jdbcTemplate.
* DATAJDBC-290 - Support ResultSetExtractor as an alternative to RowMapper.
* DATAJDBC-287 - Document the usage of JdbcConfiguration.
* DATAJDBC-285 - Add description for `@Table` and `@Column` to the reference documentation.
* DATAJDBC-282 - Dedicated insert and update methods in the JdbcRepository.
* DATAJDBC-259 - Store collections and arrays of simple types in an ARRAY column.
* DATAJDBC-111 - Support for ValueObjects/Embedded.


Changes in version 1.0.5.RELEASE (2019-02-13)
---------------------------------------------
* DATAJDBC-325 - SqlGeneratorSource needs thread safety.
* DATAJDBC-317 - Release 1.0.5 (Lovelace SR5).
* DATAJDBC-285 - Add description for `@Table` and `@Column` to the reference documentation.


Changes in version 1.0.4.RELEASE (2019-01-10)
---------------------------------------------
* DATAJDBC-313 - Update copyright years to 2019.
* DATAJDBC-303 - Fix flaky test.
* DATAJDBC-301 - Fix Travis build failing due to moved JDK8.
* DATAJDBC-297 - Release 1.0.4 (Lovelace SR4).
* DATAJDBC-287 - Document the usage of JdbcConfiguration.


Changes in version 1.1.0.M1 (2018-12-11)
----------------------------------------
* DATAJDBC-306 - Simplify reference documentation setup.
* DATAJDBC-305 - Release 1.1 M1 (Moore).
* DATAJDBC-301 - Fix Travis build failing due to moved JDK8.
* DATAJDBC-294 - ID in where clauses doesn't properly considers the NamingStrategy.
* DATAJDBC-288 - Alter visibility of JdbcConfiguration to support better extensibility.
* DATAJDBC-286 - Mapping OneToOne relationship broken for immutable entities & PostgreSQL.
* DATAJDBC-280 - The Travis build is broken due to a broken JDK download.
* DATAJDBC-276 - AggregateChange.setId requires an ID-attribute for List elements.
* DATAJDBC-273 - Creating entity via constructor assumes child properties are nested entities.
* DATAJDBC-272 - Split Spring Data JDBC project into modules.
* DATAJDBC-271 - Simplify README.
* DATAJDBC-266 - Referenced entity in one to one relationship requires an id, which it shouldn't.
* DATAJDBC-263 - When entities get created via a method with @Query annotation no AfterLoadEvent gets triggered.
* DATAJDBC-262 - Id gets updated.
* DATAJDBC-258 - Run integration tests with Microsoft SQL Server.
* DATAJDBC-246 - Make the Travis build run with different JDKs.
* DATAJDBC-221 - Introduce a Reference type for cross aggregate references.
* DATAJDBC-125 - support multiple entity references of same type.


Changes in version 1.0.3.RELEASE (2018-11-27)
---------------------------------------------
* DATAJDBC-294 - ID in where clauses doesn't properly considers the NamingStrategy.
* DATAJDBC-283 - Release 1.0.3 (Lovelace SR3).


Changes in version 1.0.2.RELEASE (2018-10-29)
---------------------------------------------
* DATAJDBC-277 - Release 1.0.2 (Lovelace SR2).


Changes in version 1.0.1.RELEASE (2018-10-15)
---------------------------------------------
* DATAJDBC-268 - Release 1.0.1 (Lovelace SR1).
* DATAJDBC-263 - When entities get created via a method with @Query annotation no AfterLoadEvent gets triggered.


Changes in version 1.0.0.RELEASE (2018-09-21)
---------------------------------------------
* DATAJDBC-267 - Fix Jdbc configuration to support multiple stores.
* DATAJDBC-265 - Include documentation about Object Mapping Fundamentals.
* DATAJDBC-264 - SqlGenerator.createInsertSql creates wrong SQL for empty column list.
* DATAJDBC-261 - Clear license indication.
* DATAJDBC-260 - Fehler in der Dokumentation.
* DATAJDBC-252 - Entity instantiation via constructor doesn't seem to work.
* DATAJDBC-251 - Manually generated ID doesn't get passed on to dependent entities.
* DATAJDBC-250 - Release 1.0 GA (Lovelace).
* DATAJDBC-218 - Add support for key column in @Column annotation.


Changes in version 1.0.0.RC2 (2018-08-20)
-----------------------------------------
* DATAJDBC-245 - Release 1.0 RC2 (Lovelace).
* DATAJDBC-242 - Reflect changes in documentation.
* DATAJDBC-229 - Add java.util.UUID into simpleTypeHolder.


Changes in version 1.0.0.RC1 (2018-07-26)
-----------------------------------------
* DATAJDBC-243 - Using @EnableJdbcRepositories and extending JdbcConfiguration causes duplicate bean registrations.
* DATAJDBC-238 - JdbcRepositoryFactory.getEntityInformation must not return null.
* DATAJDBC-237 - Remove @since annotations.
* DATAJDBC-235 - Introduce CustomConversions.
* DATAJDBC-233 - API changes for future proper support for immutable entities.
* DATAJDBC-232 - Adapt to changes to support immutable entities.
* DATAJDBC-227 - Refactorings and API improvements in preparation for DATAJDBC-224.
* DATAJDBC-226 - Extract packages not directly tied to JDBC into relational package.
* DATAJDBC-222 - Review of Reference Documentation.
* DATAJDBC-220 - improve degraph test to detect cycles across modules.
* DATAJDBC-216 - Cannot set createdDate and createdAt on primitive @Id.
* DATAJDBC-215 - Release 1.0 RC1 (Lovelace).
* DATAJDBC-214 - Update TestContainers version to one not requiring commons-lang as separate dependency.
* DATAJDBC-207 - Make Snake Case the default NamingStrategy.
* DATAJDBC-188 - Add better test for delete logic with multi level references.
* DATAJDBC-174 - Initial Reference Documentation.
* DATAJDBC-143 - Methods in JdbcEntityOperations take Domainclasses that are (possibly) superfluous.
* DATAJDBC-138 - Improve package structure.
* DATAJDBC-137 - Code Clean Up.
* DATAJDBC-106 - Support for naming columns using @Column annotation.
* DATAJDBC-102 - Make EntityInstantiator configurable.


Changes in version 1.0.0.M3 (2018-05-17)
----------------------------------------
* DATAJDBC-213 - Fix Travis build.
* DATAJDBC-212 - Adapt to SpEL extension API changes in Spring Data Commons.
* DATAJDBC-209 - The QueryAnnotationHsqlIntegrationTests#executeCustomQueryWithReturnTypeIsDate is failed at sometimes.
* DATAJDBC-206 - Update README with changes from recent issues.
* DATAJDBC-204 - Support the annotation based auditing.
* DATAJDBC-202 - Release 1.0 M3 (Lovelace).
* DATAJDBC-201 - Reduce logging performed during build.


Changes in version 1.0.0.M2 (2018-04-13)
----------------------------------------
* DATAJDBC-200 - Rename event classes to have an "Event" suffix.
* DATAJDBC-199 - Fix @since JavaDoc comments.
* DATAJDBC-198 - running integration-tests against specific db causes errors for *HsqlIntegrationTests.
* DATAJDBC-197 - AfterCreation doesn't get triggered. EventPublishingRowMapper is not used.
* DATAJDBC-196 - support for MariaDB integration-tests.
* DATAJDBC-195 - create SQL with a uniform style.
* DATAJDBC-194 - Do some polishing on the readme.
* DATAJDBC-190 - Fix some wrong/weird usage of AssertJ.
* DATAJDBC-189 - Make the DefaultNamingStrategy into default methods of the NamingStrategy.
* DATAJDBC-184 - Support snake case (delimiter character) naming strategy.
* DATAJDBC-182 - Support modifying query.
* DATAJDBC-180 - Update to latest Testcontainers version.
* DATAJDBC-179 - Provide more detailed project details.
* DATAJDBC-178 - Allow generating any namespace in MyBatisDataAccessStrategy.
* DATAJDBC-176 - Release 1.0 M2 (Lovelace).
* DATAJDBC-175 - Supports simple types as return type for annotated methods.
* DATAJDBC-172 - Support Streams, Entities, Collections and Optionals as return type for annotated methods.
* DATAJDBC-155 - JdbcRepositoryFactory should not require a DataAccessStrategy, but construct on on its own when none is available.
* DATAJDBC-130 - Support Lists.


Changes in version 1.0.0.M1 (2018-02-06)
----------------------------------------
* DATAJDBC-171 - Release 1.0 M1 (Lovelace).






























































